<?php
/**
 * AstonishMe BOPIT plugin.
 *
 * @package plugins
 *
 * @copyright (c)2007 by AstonishMe - {@link http://astonishme.co.uk/}.
 *
 * {@internal Below is a list of authors who have contributed to design/coding of this file: }}
 * @author Yabba	- {@link http://www.astonishme.co.uk/}
 * @author Stk		- {@link http://www.astonishme.co.uk/}
 *
 * @license GNU General Public License 2 (GPL) - http://www.opensource.org/licenses/gpl-license.php
 *
 * @package plugins
 */
if( !defined('EVO_MAIN_INIT') ) die( 'Please, do not access this page directly.' );

class am_bopit_plugin extends Plugin
{
	var $name = 'AM BOPIT';
	var $code = 'am_bopit';
	var $priority = 50;
	var $version = '2.3';
	var $author = 'AstonishMe';
	var $group = 'AstonishMe';
	var $number_of_installs = 1;
	var $help_url = 'http://b2evo.astonishme.co.uk/index.php/2007/05/06/bopit';


	// internal
	var $plugin_list = array();
	var $skin_list = array();
	var $latest_version_info = array();
	var $news = '';

	// 1.8.x
	function am_bopit_plugin()
	{
		$this->PluginInit();
	}


	// 1.9.x 1.10.x
	function PluginInit()
	{
		$this->long_desc = T_( 'This plugin gets the latest skins and plugins version information from').'  AstonishMe';
		$this->short_desc = T_( 'The easy way to ensure that your plugins and skins are current' );
	}


	function AdminEndHtmlHead()
	{
		global $admin_Plugins;
		$the_url = $this->get_plugin_url();
		echo '<link rel="stylesheet" href="'.$the_url.'am_bopit.css" type="text/css" />';
		//param() tilts if you try and get "ctrl" using it :(
		$current_bit = ( isset( $_GET['ctrl'] ) ? $_GET['ctrl'] : '' );

		if( $current_bit == 'plugins' && $admin_Plugins && param( 'action', 'string' ) != 'edit_settings' )
		{
			if( empty($this->latest_version_info ) )
				$this->latest_version_info = $this->get_latest(); // get the latest versions details

			// check again as version file may not have been available
			if( $this->latest_version_info )
				$this->do_admin_check( $admin_Plugins );
		}
	}


	/**
	 * Colour codes ( and adds a download link if relevant ) each plugins short description
	 * This enables you to tell at a glance if any plugins need upgrading
	 *
	 * @param array $which_set - currently only $AdminPlugins is used
	 */
	function do_admin_check( & $which_set )
	{
		$which_set->restart();	// reset the list

		while( $a_plugin = & $which_set->get_next() )
		{ // step through each of the plugins
			$short_desc = '<div class="am_bopit_unknown" title="'.T_( 'No version information available for this plugin').'">'.$a_plugin->short_desc.'</div>';
			foreach( $this->latest_version_info as $item )
			{	// step through each of the known versions
				if ( $item->name == $a_plugin->code )
				{ // we've found the plugin - lets check if it's current
					$short_desc = ( $item->version > $a_plugin->version ?
						'<div class="am_bopit_old"><a href="'.$item->download_link.'" title="'.T_( 'Download the upgrade' ).'">'.get_icon( 'download','imgtag',array('title'=>' '.T_( 'Download the upgrade' ).' ',) ).$a_plugin->short_desc.'</a></div>' :
						'<div class="am_bopit_ok" title="'.T_( 'This is the latest version').'">'.$a_plugin->short_desc.'</div>' );
					break;
				}
			}
			$a_plugin->short_desc = $short_desc; // add our stuff to the short description ;)
		}
	}


	function AdminAfterMenuInit()
	{	// add our tab
		$this->register_menu_entry( 'AM BOPIT' );
	}


	function AdminTabAction()
	{
		global $basepath, $skins_subdir, $AvailablePlugins;
		if( empty( $this->latest_version_info ) )
			$this->latest_version_info = $this->get_latest();

		if( empty($AvailablePlugins) || ! is_a( $AvailablePlugins, 'Plugins_no_DB' ) )
		{
			load_class('plugins/model/_plugins_admin_no_db.class.php');
			$AvailablePlugins = & new Plugins_admin_no_DB();
			$AvailablePlugins->discover();
			$AvailablePlugins->sort('name');
		}

		$AvailablePlugins->restart();
		while( $a_Plugin = & $AvailablePlugins->get_next() )
		{
			$this->plugin_list[] = array( 'name' => $a_Plugin->code, 'version' => $a_Plugin->version );
		}

		$skins = $basepath.$skins_subdir;

		if ( @$skin_dir = opendir( $skins ) )
		{
			while ( ( $file = readdir( $skin_dir ) ) !== false )
			{
				if( is_file( $skins.$file.'/_am_version_info.php' ) )
				{
					include $skins.$file.'/_am_version_info.php';
					if( !empty( $skin_details ) ) $this->skin_list[] = $skin_details;
					unset( $skin_details ); // make sure it's empty for the next one
				}
			}
			closedir( $skin_dir );
		}
	}


	function AdminTabPayload()
	{
		echo '<h3>AstonishMe - '.T_( 'Back-Office Plug-In Tool' ).' (AM-BOPIT)</h3><p>'
					.T_( 'Items in' ).'<span class="am_bopit_old"> '
					.T_( 'red' ).' </span>'
					.T_( 'are OLD. Items in' ).'<span class="am_bopit_ok"> '
					.T_( 'green' ).' </span>'
					.T_( 'are OKAY.').'</p>';
		$table_head = '<table class="am_bopit_list"><tr><th>'.T_( 'Actions' ).'</th><th>'.T_( 'Name' ).'</th><th>'.T_( 'Reason' ).'</th></tr>'."\n";
		if ( $this->latest_version_info )
		{
			echo '<p><strong>'.T_( 'Plugins' ).':</strong></p>'.$table_head;
			foreach( $this->latest_version_info as $item )
			{
				if ( $item->type == 'plugin' ) $this->check_version( $item, $this->plugin_list );
			}
			echo '</table><p><strong>'.T_( 'Skins' ).':</strong></p>'.$table_head;
			foreach( $this->latest_version_info as $item )
			{
				if ( $item->type == 'skin' ) $this->check_version( $item, $this->skin_list );
			}
			echo '</table>';
		}
		else
		{
			echo '<p class="error">'.T_( 'Error : No version information received from the server or no supported plugins/skins installed' ).'</p>';
		}
	}


	function GetDefaultSettings()
	{
		return array(
			'update_url' => array(
				'label' => T_( 'Update url'),
				'defaultvalue' => 'http://astonishme.co.uk/version_info/version_',
				'type' => 'text',
				'note' => T_( 'This is the url to the version information files'),
				),
			'hostname' => array(
				'label' => T_( 'Host Name'),
				'defaultvalue' => 'astonishme.co.uk',
				'type' => 'text',
				'note' => T_( 'This is the hostname for the above url'),
				),
			);
	}


	function get_latest()
	{
		global $app_version;
		$version_file = strtolower( implode( '-', array_slice( explode( '.', $app_version ), 0, 2 ) ) );
		$url = $this->Settings->get( 'update_url' ).$version_file.'.xml';

		preg_match( '#(//)?([^/]+?)/#', $url, $parts );
		$host =  $this->Settings->get( 'hostname' );
		if( $host)
		{
			if( $fp = fsockopen( $host, 80, $errno, $errstr, 30) )
			{	// we can use fsock
				$output = '';
				fwrite($fp, 'GET '.$url." HTTP/1.0\r\nHost: $host\r\n\r\n");
				while (!feof($fp)) { $output .= fgets($fp, 128); }
				fclose($fp);
			} elseif (extension_loaded('curl'))
			{ // we can use curl
				$ch = curl_init();
				curl_setopt($ch, CURLOPT_URL, $url);
				curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
				$output = curl_exec ($ch);
				curl_close ($ch);
			}
			$am_results = '';
			preg_match_all( '#<plugin>([\s\S]+?)</plugin>#', $output, $fred );
			$am_results = ( empty( $fred[1] ) ? array() : $this->extract_data( $fred[1], 'plugin' ) );
			preg_match_all( '#<skin>([\s\S]+?)</skin>#', $output, $fred );
			$am_results += ( empty( $fred[1] ) ? array() : $this->extract_data( $fred[1], 'skin' ) );
			return $am_results;
		}
		return false;
	}


	function extract_data( $data, $which )
	{
		$am_results = array();
		foreach( $data as $joe )
		{	// parse each item
			preg_match_all( '#<([^>]+?)>(.+?)</\1>#', $joe, $params );
			for( $peter = 0; $peter < sizeof( $params[1] ); $peter++ )
			{	// set each var
				$var = 'item_'.$params[1][$peter];
				$$var = $params[2][$peter];
			}
			// create an entry for the details
			$am_results[] = new am_version_info( array(
						'type' => $which,
						'name' => ( isset( $item_code ) ? $item_code : '' ),
						'title' => ( isset( $item_name ) ? $item_name : '' ),
						'version' => ( isset( $item_version ) ? $item_version : '' ),
						'download_link' => ( isset( $item_download ) ? $item_download : '' ),
						'homepage_link' => ( isset( $item_home ) ? $item_home : '' ),
						'support_link' => ( isset( $item_support ) ? $item_support : '' ),
						'reason' => ( isset( $item_reason ) ? $item_reason : '' ),
						'thumbnail' => ( isset( $item_thumb ) ? $item_thumb : '' ), // only used by skins
						)
					);
			for( $peter = 0; $peter < sizeof( $params[1] ); $peter++ )
			{	// set each var
				$var = 'item_'.$params[1][$peter];
				unset( $$var );
			}
		}
		return $am_results;
	}

	function check_version( $current, $list, $display = true )
	{
		// set all the message strings
		$download = ( empty( $current->download_link ) ? '' : '<a href="'.$current->download_link.'">'.get_icon( 'download','imgtag',array('title'=>' '.T_( 'Download the Package' ).' ',) ).'</a>' );
		$upgrade = ( empty( $current->download_link ) ? '' : '<a href="'.$current->download_link.'">'.get_icon( 'download','imgtag',array('title'=>' '.T_( 'Download the Upgrade' ).' ',) ).'</a>' );
		$homepage = ( empty( $current->homepage_link ) ? '' : '<a href="'.$current->homepage_link.'">'.get_icon( 'www','imgtag',array('title'=>' '.T_( 'Home Page' ).' ',) ).'</a>' );
		$support = ( empty( $current->support_link ) ? '' : '<a href="'.$current->support_link.'">'.get_icon( 'help','imgtag',array('title'=>' '.T_( 'Support Page' ).' ',)  ).'</a>' );
		$ver = T_( 'not installed' );
		$output = '<tr class="am_bopit_unknown"><td>'.$homepage.'&nbsp;'.$support.'&nbsp;'.$download.'</td><td>'.$current->title.' - '.$current->version.'    '.T_( ' [not installed] ' ).'</td><td></td></tr>';
		foreach ( $list as $item )
		{
			if ( $item['name'] == $current->name )
			{
				if ( version_compare( $item['version'], $current->version, 'lt' ) )
				{
					$ver = '<span class="am_bopit_old">'.$current->version.'</span>';
					$output = '<tr class="am_bopit_old"><td>'.$homepage.'&nbsp;'.$support.'&nbsp;'.$upgrade.'</td><td>'.$current->title.' - '.$current->version.'</td><td>'.$current->reason.'</td></tr>';
					break;
				} else {
					$ver = '<span class="am_bopit_ok">'.$current->version.'</span>';
					$output = '<tr class="am_bopit_ok"><td>'.$homepage.'&nbsp;'.$support.'</td><td>'.$current->title.' - '.$current->version.'</td><td></td></tr>';
					break;
				}
			}
		}
		if( $display )
			echo $output."\n\r";

		return $output;
	}
}

if( !class_exists( 'am_version_info' ) )
{
	class am_version_info
	{
		var $type;
		var $name;
		var $version;
		var $title;
		var $download_link;
		var $homepage_link;
		var $support_link;
		var $thumbnail;
		var $reason;

		function am_version_info( $params )
		{
			if (isset( $params['type']) ) $this->type = $params['type'];
			if (isset( $params['name']) ) $this->name = $params['name'];
			if (isset( $params['version']) ) $this->version = $params['version'];
			if (isset( $params['download_link']) ) $this->download_link = $params['download_link'];
			if (isset( $params['homepage_link']) ) $this->homepage_link = $params['homepage_link'];
			if (isset( $params['support_link']) ) $this->support_link = $params['support_link'];
			if (isset( $params['title']) ) $this->title = $params['title'];
			if (isset( $params['thumbnail']) ) $this->thumbnail = $params['thumbnail']; // currently unused
			if (isset( $params['reason']) ) $this->reason = $params['reason'];
			return $this;
		}
	}
}
?>